package com.vk;

import java.io.*;
import java.awt.event.*;
import java.util.*;
import javax.sound.sampled.*;
import javax.sound.midi.*;

public class PlaySound implements Runnable{ 
 //
 final int bufSize = 16384;
 int num = 0;
 String errStr;
 Vector sounds = new Vector();
 Thread thread;
 Object currentSound;
 Sequencer sequencer;
 Synthesizer synthesizer;
 MidiChannel channels[]; 
 int[] val;
 //
 public PlaySound(String[] afn, int[] v){
  val=v; loadJuke(afn); open();  
 }
 //
 private void loadJuke(String[] afn){
  try{for(int i=0; i < afn.length; i++){
     File leafFile = new File(afn[i]);
     addSound(leafFile);}
  }
  catch(SecurityException ex){reportStatus(ex.toString());}
  catch(Exception ex){reportStatus(ex.toString());}
 }
 //
 private void addSound(File file){
  String s = file.getName();
  if(s.endsWith(".au") || s.endsWith(".AU") ||
     s.endsWith(".rmf") || s.endsWith(".RMF") ||
     s.endsWith(".mid") || s.endsWith(".MID") ||
     s.endsWith(".wav") || s.endsWith(".WAV") ||
     s.endsWith(".aif") || s.endsWith(".AIF") ||
     s.endsWith(".aiff") || s.endsWith(".AIFF") )
   {sounds.add(file); }
 }
 //
 private void open(){
  try{sequencer = MidiSystem.getSequencer();
   if(sequencer instanceof Synthesizer){
    synthesizer = (Synthesizer)sequencer; channels = synthesizer.getChannels();} 
  }catch(Exception ex){ex.printStackTrace(); return;}
 }
 private void reportStatus(String msg){
  if((errStr = msg) != null){System.out.println(errStr);}
 }
 //
 public Thread getThread(){return thread;}
 //
 public void start(){thread = new Thread(this); thread.setName("Juke");
      thread.setPriority(Thread.MAX_PRIORITY); thread.start(); }
 //
 public void stop(){if(thread != null){thread.interrupt();} thread = null;}
 //
 public void run(){
  do{
   for(; num < sounds.size() && thread != null; num++){
    if(loadSound(sounds.get(num)) == true){playSound();}
    try{thread.sleep(222);}catch(Exception e){break;}
   } num = 0; if( val[2] == 0 ){thread = null;}
  }while(thread != null);
  thread = null; currentSound = null;
 }
 //
 private boolean loadSound(Object object){
  if(object instanceof File){
   try{currentSound = AudioSystem.getAudioInputStream((File)object);}
   catch(Exception e1){
    try{FileInputStream is = new FileInputStream((File) object);
        currentSound = new BufferedInputStream(is,1024);}
    catch(Exception e3){e3.printStackTrace(); currentSound = null; return false;} 
  }}
  if(sequencer == null){currentSound = null; return false;} 
  if(currentSound instanceof AudioInputStream){
   try{
    AudioInputStream stream = (AudioInputStream) currentSound;
    AudioFormat format = stream.getFormat();
           // convert ALAW/ULAW to PCM
    if((format.getEncoding() == AudioFormat.Encoding.ULAW)
       || (format.getEncoding() == AudioFormat.Encoding.ALAW)) 
     {AudioFormat tmp = new AudioFormat(
       AudioFormat.Encoding.PCM_SIGNED, format.getSampleRate(), format.getSampleSizeInBits()*2,
       format.getChannels(), format.getFrameSize()*2, format.getFrameRate(), true);
      stream = AudioSystem.getAudioInputStream(tmp,stream); format = tmp; }
    DataLine.Info info = new DataLine.Info(Clip.class, stream.getFormat(), 
                                           ((int)stream.getFrameLength()*format.getFrameSize()));
    Clip clip = (Clip) AudioSystem.getLine(info);
    clip.open(stream); currentSound = clip;
   }catch(Exception ex){ex.printStackTrace(); currentSound = null; return false; } }
  else
  if(currentSound instanceof BufferedInputStream){
   try{sequencer.open();
     sequencer.setSequence((BufferedInputStream)currentSound);
   }catch(InvalidMidiDataException imde){System.out.println("Unsupported audio file.");
     currentSound = null; return false;}
    catch(Exception ex){ex.printStackTrace(); currentSound = null; return false; }
  } return true;
 }
 //
 private void playSound(){
  setGain(); setPan(); int ns = val[3]; 
  if(currentSound instanceof BufferedInputStream && thread != null){
   sequencer.start();
   while( sequencer.isRunning() && thread != null ){ try{thread.sleep(ns);}catch (Exception e){break;} }
   sequencer.stop(); sequencer.close(); }
  else
  if(currentSound instanceof Clip && thread != null){
   Clip clip = (Clip) currentSound; clip.start();
   while( clip.isActive() && thread != null ){ try{thread.sleep(ns);}catch(Exception e){break;} }
   clip.stop(); clip.close();
  } currentSound = null; 
 }
 //
 private void setPan(){
  int value = val[0]; if(currentSound instanceof Clip){
   try{ Clip clip = (Clip) currentSound;
    FloatControl panControl = (FloatControl)clip.getControl(FloatControl.Type.PAN);
    panControl.setValue(value/100.0f);
   }catch(Exception ex){ex.printStackTrace();} }
  else
  if(currentSound instanceof BufferedInputStream){
   for(int i = 0; i < channels.length; i++){                
    channels[i].controlChange(10, (int)(((double)value+100.0)/200.0*127.0));
  }}
 }
 private void setGain(){
  double value = val[1]/100.0; 
  if(currentSound instanceof Clip){
   try{ Clip clip = (Clip) currentSound;
    FloatControl gainControl = (FloatControl)clip.getControl(FloatControl.Type.MASTER_GAIN);
    float dB = (float)(Math.log(value==0.0?0.0001:value)/Math.log(10.0)*20.0);
    gainControl.setValue(dB);
   }catch(Exception ex){ex.printStackTrace();} }
  else
  if(currentSound instanceof BufferedInputStream){
   for(int i = 0; i < channels.length; i++){                
    channels[i].controlChange(7, (int)(value*127.0));
  }}
 }
}
