package com.vk;

import java.io.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.sound.sampled.*;

import com.vk.*;

public class SoundFrame extends JDialog implements ActionListener {
 protected boolean ru; TargetDataLine line;
 ByteArrayOutputStream out; AudioFormat format; TimeMon tm = new TimeMon();
 int sr,ss,ch,mo,ifsx,ifsy,ivs1,ivs2,p3,p4; double sec; String wdir,fin,fie,txt;
 Container pcont; Box hbox,vbox; JButton hlp,sta,sto,exi; JLabel lab; JTextField inpf,inpt;
 AudioFileFormat.Type afft;
 //
 public SoundFrame(String mwdir,int x, int y, int mod, int[] par){
  setLocation(x,y); setResizable(false); setModal(true);
  pcont = getContentPane(); vbox = Box.createVerticalBox();
  ifsx=30; ifsy=20; ivs1=10; ivs2=20;  
  sr=par[0]; ss=par[1]; ch=par[2]; p3=par[3]; p4=par[4]; wdir=mwdir; mo=mod; 
  if( p3 < 1 || p3 > 3 ){p3=1;}
  switch(mo){
   case 1: setTitle("Record Sound to File"); 
    switch(p3){
     case 1: afft=AudioFileFormat.Type.WAVE; fie=".wav"; break;
     case 2: afft=AudioFileFormat.Type.AU; fie=".au"; break;
     case 3: afft=AudioFileFormat.Type.AIFF; fie=".aif"; break;
    }
    hbox = Box.createHorizontalBox();
    lab = new JLabel("File name:      "); hbox.add(lab);
    inpf = new JTextField("untitled"); hbox.add(inpf);
    vbox.add(hbox);  vbox.add(Box.createVerticalStrut(ivs1));
    hbox = Box.createHorizontalBox();
    lab = new JLabel("Time of recording ( sec. ) :      "); hbox.add(lab);
    inpt = new JTextField(" "); hbox.add(inpt);
    vbox.add(hbox);
    vbox.add(Box.createVerticalStrut(ivs2));
    hbox = Box.createHorizontalBox(); 
    hlp = new JButton("Help"); hlp.setEnabled(true);
    hlp.setActionCommand("help"); hlp.addActionListener(this); hbox.add(hlp);
    sta = new JButton("Start"); sta.setEnabled(true);
    sta.setActionCommand("start"); sta.addActionListener(this); hbox.add(sta);
    sto = new JButton("Stop"); sto.setEnabled(false);
    sto.setActionCommand("stop"); sto.addActionListener(this); hbox.add(sto);
    exi = new JButton("Exit"); exi.setEnabled(true);
    exi.setActionCommand("exit"); exi.addActionListener(this); hbox.add(exi);
    vbox.add(hbox);    
    pcont.add(Box.createVerticalStrut(ifsy), BorderLayout.NORTH);
    pcont.add(Box.createHorizontalStrut(ifsx), BorderLayout.WEST);
    pcont.add(vbox, BorderLayout.CENTER);
    pcont.add(Box.createHorizontalStrut(ifsx), BorderLayout.EAST);
    pcont.add(Box.createVerticalStrut(ifsy), BorderLayout.SOUTH);
    pack(); setVisible(true);
   break;
  }
 }
 //
 public void actionPerformed(ActionEvent e){
       if("help".equals(e.getActionCommand())){
        JOptionPane.showMessageDialog(MyPro.parent(),MyPro.txt,"Help Info",JOptionPane.INFORMATION_MESSAGE);} 
  else if("start".equals(e.getActionCommand())){
        sta.setEnabled(false); sto.setEnabled(true); exi.setEnabled(false); hlp.setEnabled(false); captureAudio(); tm.start();} 
  else if("stop".equals(e.getActionCommand())){
        sta.setEnabled(true); sto.setEnabled(false); exi.setEnabled(true); hlp.setEnabled(true); ru=false; tm.stop();}
  else if("exit".equals(e.getActionCommand())){setVisible(false); dispose();}
 }
 //
 private void captureAudio(){
  try{format = getFormat();
   DataLine.Info info = new DataLine.Info(TargetDataLine.class, format);
   line = (TargetDataLine)AudioSystem.getLine(info);
   line.open(format); line.start();
   //
   Runnable runner = new Runnable(){
    int bufSize = (int)format.getSampleRate()*format.getFrameSize();
    byte[] buf = new byte[bufSize];
    //
    public void run(){ int k; short sh,sh1;
     out = new ByteArrayOutputStream();
     ru = true;
     try{
      while(ru){
       int c = line.read(buf,0,buf.length);
       if(c > 0){
        if( p4 != 100 ){
         if(format.getFrameSize() == 1){
          for(k=0; k < c; k++){sh=buf[k]; if(sh < 0){sh += 256;} sh=(short)(sh*p4/100);
           if(sh > 255){sh=255;} if(sh > 127){sh -= 256;} buf[k]=(byte)sh;
         }}
         if(format.getFrameSize() == 2){int tm;
          for(k=0; k < c; k+=2){sh=buf[k]; if(sh < 0){sh += 256;} tm=sh*256; sh=buf[k+1]; if(sh < 0){sh += 256;} tm += sh;
           tm=tm*p4/100; sh=(short)(tm/256); sh1=(short)(tm-sh*256); if(sh > 127){sh -= 256;} buf[k]=(byte)sh;
           if(sh1 > 127){sh1 -= 256;} buf[k+1]=(byte)sh1;
        }}}
        out.write(buf,0,c);
       }
      } line.stop(); line.close(); out.flush(); out.close();
      fin=inpf.getText().trim()+fie; if( wdir != null ){fin=wdir+"/"+fin;} saveToFile(fin,afft);
     }catch(IOException e){System.err.println("I/O problems: "+e); return;}
   }};
   //
   Thread captureThread = new Thread(runner);
   captureThread.start();
  }catch (LineUnavailableException e){System.err.println("Line unavailable: "+e); return;}
 }
 //
 private AudioFormat getFormat(){
  float sampleRate = (float)sr;  
  int sampleSizeInBits = ss;  
  int channels = ch;  
  boolean signed = true;
  boolean bigEndian = true;
  return new AudioFormat(sampleRate,sampleSizeInBits,channels,signed,bigEndian);
 }
 //
 private void saveToFile(String name, AudioFileFormat.Type fileType) {
  byte[] audio = out.toByteArray();
  InputStream is = new ByteArrayInputStream(audio);
  format = getFormat();
  AudioInputStream ais = new AudioInputStream(is,format,audio.length/format.getFrameSize());
  if(ais == null){return;}
  File file = new File(name);
  try{
   if(AudioSystem.write(ais,fileType,file) == -1){
    throw new IOException("Problems writing to file");
  }}catch(Exception ex){System.err.println(ex.toString());}
 }
 //
 class TimeMon implements Runnable{ 
  private Thread thread;
  //
  public TimeMon(){}
  //
  public void start(){
   thread = new Thread(this); thread.start();
  }
  //
  public void stop(){if(thread != null){thread.interrupt();} thread = null;}
  //
  public void run(){
   sec = 0; inpt.setText(String.valueOf(sec));
   while(ru){
    if( (line != null) && (line.isActive()) )
     {long msec = (long)(line.getMicrosecondPosition()/1000); sec=msec/1000.0;}
    try{Thread.sleep(100);}catch(Exception e){break;}
    inpt.setText(String.valueOf(sec));
    while( (line != null) && !line.isActive() ) 
     {try{Thread.sleep(10);}catch(Exception e){break;}
  }}}
 }
}
