package com.vk;

public class newPro{

 // procedure fq = fft(fx,k) was translated from a similar fortran procedure
 // obtained from Pavel Petrashen. It calculates
 //     fq[n] = sum{m = 0,...,N-1} exp( sign(k)*2*pi*i*n*m/N )*fx[m] 
 // where N = 2^abs(k) with k to be integer, n = 0,...,N-1
 //
 public static double[] fft(double[] car, int k){
  int i,j,ks,l,m,m1,ms,n,n1,n2,ns; double c,c0,c1; 
  ks = Math.abs(k); ns =  1; for( i=0; i < ks; i++ ){ ns *= 2; } ms=2*ns;
  double[] ca = new double[ms]; for( i=0; i < ms; i++ ){ ca[i]=car[i]; }
  double[] cb = new double[ms]; double[] cc = new double[ns];
  int[] inv = new int[ns]; inv[0]=1; n2=1;
  for( l=0; l < ks; l++ ){
   for( i=0; i < n2; i++ ){
    n=i+n2; inv[n]=inv[i]*2; inv[i]=inv[n]-1;
   } n2 *= 2;
  }
  n2 /= 2; c=2.*Math.PI/ns; cc[0]=Math.cos(c); cc[1]=Math.sin(c);
  for( i=1; i < n2; i++ ){ j=2*i; cc[j]=cc[j-2]*cc[0]-cc[j-1]*cc[1]; cc[j+1]=cc[j-1]*cc[0]+cc[j-2]*cc[1]; } 
  for( i=0; i < ns; i++ ){ m=2*(inv[i]-1); j=2*i; cb[m]=ca[j]; cb[m+1]=ca[j+1]; }
  for( i=0; i < n2; i++ ){ j=2*i; m=4*i+2; l=m-2; ca[j]=cb[l]+cb[m]; 
   ca[j+1]=cb[l+1]+cb[m+1]; j=j+2*n2; ca[j]=cb[l]-cb[m]; ca[j+1]=cb[l+1]-cb[m+1]; }
  m1=n2;
  for( i=1; i < ks; i++ ){ m=m1+2; m1 /= 2; 
   for( n=m; n <= ns; n += 2){ l=(n-1)/(m-2); l *= m1; j=2*(l-1); c=cc[j]; c0=cc[j+1]; if( k < 0 ){ c0=-c0; }
    j=2*(n-1); c1=ca[j]; ca[j]=c1*c-ca[j+1]*c0; ca[j+1]=c1*c0+ca[j+1]*c; } 
   for( l=0; l < ms; l++ ){ cb[l]=ca[l]; }

   for( n=0; n < n2; n++ ){ j=2*n; m=4*n+2; l=m-2; ca[j]=cb[l]+cb[m]; 
    ca[j+1]=cb[l+1]+cb[m+1]; j=j+2*n2; ca[j]=cb[l]-cb[m]; ca[j+1]=cb[l+1]-cb[m+1];
   }
  } return ca;
 } 

}
